 /*
 *Driver for the card pcie bridge.

 *Copyright (C) 2019 AVerMedia TECHNOLOGIES, Inc.

 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.

 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.

 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef BOARD_I2C_H
#define BOARD_I2C_H

#ifdef __cplusplus
extern "C" {
#endif

enum
{
    I2C_BUS_COM,
    I2C_BUS_COM_1,
    I2C_BUS_SEU,
    BOARD_I2C_BUS_NUM,    
};

typedef struct
{
	const char *name;
	unsigned short addr;
	void *context;
}i2c_dev_info_t;


const char *board_get_i2c_bus_name(int no);
int board_i2c_init(cxt_mgr_handle_t cxt_mgr,unsigned long dev_id);


#ifdef __cplusplus
}
#endif

#endif /* BOARD_I2C_H */

