 /*
 *Driver for the card pcie bridge.

 *Copyright (C) 2019 AVerMedia TECHNOLOGIES, Inc.

 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.

 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.

 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef TYPEDEF_H
#define TYPEDEF_H

#ifdef __cplusplus
extern "C" {
#endif

#ifndef NULL
#define NULL ((void *)0)
#endif    

#define Bit(x) (1<<(x))
#define BITMASK(x) ((1<<(x))-1) 

#ifndef offsetof    
#define offsetof(TYPE, MEMBER)  ((unsigned long )&((TYPE *)0)->MEMBER)    
#endif    
#ifndef container_of  
#define container_of(ptr, type, member) ({                      \
         const typeof( ((type *)0)->member ) *__mptr = (ptr);    \
         (type *)( (char *)__mptr - offsetof(type,member) );})    
#endif    

typedef unsigned char U8_T;
typedef char S8_T;
typedef unsigned short U16_T;
typedef short S16_T;
typedef unsigned int U32_T;
typedef int S32_T;
typedef unsigned long SIZE_T;
typedef unsigned long long U64_T;
typedef long long S64_T;
typedef enum 
{
    FALSE,
    TRUE,
} BOOL_T;



#ifdef __cplusplus
}
#endif

#endif /* TYPEDEF_H */

