 /*
 *Driver for the Analog Devices ADV7619 IC

 *Copyright (C) 2019 AVerMedia TECHNOLOGIES, Inc.

 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.

 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.

 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef ADV7619_REG_H
#define ADV7619_REG_H

#ifdef __cplusplus
extern "C" {
#endif


typedef enum
{
 
    ADV7619_IO_REG_VIDEO_STANDARD                             =0x00,
    ADV7619_IO_REG_PRIMARY_MODE                               =0x01,
    ADV7619_IO_REG_IO_REG_02                                  =0x02,
    ADV7619_IO_BIT_ALT_GAMMA                                  =Bit(3),
    ADV7619_IO_BIT_OP_656_RANGE                               =Bit(2),
    ADV7619_IO_BIT_RGB_OUT                                    =Bit(1),
    ADV7619_IO_BIT_ALT_DATA_SAT                               =Bit(0),

    ADV7619_IO_REG_IO_REG_03                                  =0x03,
    ADV7619_IO_REG_IO_REG_04                                  =0x04,
    ADV7619_IO_XTAL_FREQ_SEL_27M                         = (0 <<1),
    ADV7619_IO_XTAL_FREQ_SEL_28_63636M                   = (0x1 <<1),   
    ADV7619_IO_XTAL_FREQ_SEL_24_576M                     = (0x2 <<1),      
    ADV7619_IO_XTAL_FREQ_SEL_24M                         = (0x3 <<1),
    ADV7619_IO_XTAL_FREQ_SEL_MASK                        = (0x3 <<1),
    ADV7619_IO_OP_CH_SEL_GBR_YUV                         = (0x0<<5),
    ADV7619_IO_OP_CH_SEL_GRB_YVU                         = (0x1<<5),
    ADV7619_IO_OP_CH_SEL_BGR_UYV                         = (0x2<<5),
    ADV7619_IO_OP_CH_SEL_RGB_VYU                         = (0x3<<5),
    ADV7619_IO_OP_CH_SEL_BRG_UVY                         = (0x4<<5),
    ADV7619_IO_OP_CH_SEL_RBG_VUY                         = (0x5<<5),   
    ADV7619_IO_OP_CH_SEL_MASK                            = (0x7<<5),
        
    ADV7619_IO_REG_IO_REG_05                                  =0x05,
    ADV7619_IO_BIT_F_OUT_SEL                                  =Bit(4),
    ADV7619_IO_BIT_DATA_BLANK_EN                              =Bit(3),
    ADV7619_IO_BIT_AVCODE_INSERT_EN                           =Bit(2),
    ADV7619_IO_BIT_REPL_AV_CODE                               =Bit(1),
    ADV7619_IO_BIT_OP_SWAP_CB_CR                              =Bit(0),

    ADV7619_IO_REG_IO_REG_06                                  =0x06,
    ADV7619_IO_BIT_VS_OUT_SEL                                 =Bit(7),
    ADV7619_IO_BIT_INV_F_POL                                  =Bit(3),
    ADV7619_IO_BIT_INV_VS_POL                                 =Bit(2),
    ADV7619_IO_BIT_INV_HS_POL                                 =Bit(1),
    ADV7619_IO_BIT_INV_LLC_POL                                =Bit(0),

    ADV7619_IO_REG_IO_REG_0B                                  =0x0B,
    ADV7619_IO_BIT_CORE_PDN                                   =Bit(1),
    ADV7619_IO_BIT_XTAL_PDN                                   =Bit(0),

    ADV7619_IO_REG_IO_REG_0C                                  =0x0C,
    ADV7619_IO_BIT_POWER_DOWN                                 =Bit(5),
    ADV7619_IO_BIT_CP_PWRDN                                   =Bit(2),
    ADV7619_IO_BIT_PADS_PDN                                   =Bit(0),

    ADV7619_IO_REG_IO_REG_12                                  =0x12,
    ADV7619_IO_BIT_CP_STDI_INTERLACED                         =Bit(4),
    ADV7619_IO_BIT_CP_INTERLACED                              =Bit(3),
    ADV7619_IO_BIT_CP_PROG_PARM_FOR_INT                       =Bit(2),
    ADV7619_IO_BIT_CP_FORCE_INTERLACED                        =Bit(1),
    ADV7619_IO_BIT_CP_NON_STD_VIDEO                           =Bit(0),

    ADV7619_IO_REG_IO_REG_14                                  =0x14,
    ADV7619_IO_REG_IO_REG_15                                  =0x15,
    ADV7619_IO_BIT_TRI_AUDIO                                  =Bit(4),
    ADV7619_IO_BIT_TRI_SYNCS                                  =Bit(3),
    ADV7619_IO_BIT_TRI_LLC                                    =Bit(2),
    ADV7619_IO_BIT_TRI_PIX                                    =Bit(1),

    ADV7619_IO_REG_IO_REG_16                                  =0x16,
    ADV7619_IO_BIT_PLL_DIV_MAN_EN                             =Bit(7),

    ADV7619_IO_REG_LLC_DLL                                    =0x19,
    ADV7619_IO_BIT_LLC_DLL_EN                                 =Bit(7),

    ADV7619_IO_REG_ALSB_CONTROL                               =0x1B,
    ADV7619_IO_BIT_SAMPLE_ALSB                                =Bit(0),

    ADV7619_IO_REG_HPA_REG1                                   =0x20,  //tt 0605
    ADV7619_IO_BIT_HPA_MAN_VALUE_A                            =Bit(7),
    ADV7619_IO_BIT_HPA_MAN_VALUE_B                            =Bit(6),
    ADV7619_IO_BIT_HPA_TRISTATE_A                             =Bit(3),
    ADV7619_IO_BIT_HPA_TRISTATE_B                             =Bit(2),

    ADV7619_IO_REG_HPA_REG2                                   =0x21,
    ADV7619_IO_BIT_HPA_STATUS_PORT_A                          =Bit(3),
    ADV7619_IO_BIT_HPA_STATUS_PORT_B                          =Bit(2),

    ADV7619_IO_REG_IO_REG_30                                  =0x30,
    ADV7619_IO_BIT_PIXBUS_MSB_TO_LSB_REORDER                  =Bit(4),

    ADV7619_IO_REG_IO_REG_33                                  =0x33,
    ADV7619_IO_BIT_LLC_DLL_MUX                                =Bit(6),

    ADV7619_IO_REG_INT_STATUS                                 =0x3F,
    ADV7619_IO_BIT_INTRQ_RAW                                  =Bit(1),
    ADV7619_IO_BIT_INTRQ2_RAW                                 =Bit(0),

    ADV7619_IO_REG_INT1_CONFIGURATION                         =0x40,
    ADV7619_IO_BIT_STORE_UNMASKED_IRQS                        =Bit(4),
    ADV7619_IO_BIT_EN_UMASK_RAW_INTRQ                         =Bit(3),
    ADV7619_IO_BIT_MPU_STIM_INTRQ                             =Bit(2),

    ADV7619_IO_REG_INT2_CONFIGURATION                         =0x41,
    ADV7619_IO_BIT_CP_LOCK_UNLOCK_EDGE_SEL                    =Bit(5),
    ADV7619_IO_BIT_STDI_DATA_VALID_EDGE_SEL                   =Bit(4),
    ADV7619_IO_BIT_EN_UMASK_RAW_INTRQ2                        =Bit(3),
    ADV7619_IO_BIT_INT2_POL                                   =Bit(2),

    ADV7619_IO_REG_RAW_STATUS_1                               =0x42,
    ADV7619_IO_BIT_STDI_DATA_VALID_RAW                        =Bit(4),
    ADV7619_IO_BIT_CP_UNLOCK_RAW                              =Bit(3),
    ADV7619_IO_BIT_CP_LOCK_RAW                                =Bit(2),

    ADV7619_IO_REG_INTERRUPT_STATUS_1                         =0x43,
    ADV7619_IO_BIT_STDI_DATA_VALID_ST                         =Bit(4),
    ADV7619_IO_BIT_CP_UNLOCK_ST                               =Bit(3),
    ADV7619_IO_BIT_CP_LOCK_ST                                 =Bit(2),

    ADV7619_IO_REG_INTERRUPT_CLEAR_1                          =0x44,
    ADV7619_IO_REG_INTERRUPT2_MASKB_1                         =0x45,
    ADV7619_IO_BIT_STDI_DATA_VALID_MB2                        =Bit(4),
    ADV7619_IO_BIT_CP_UNLOCK_MB2                              =Bit(3),
    ADV7619_IO_BIT_CP_LOCK_MB2                                =Bit(2),

    ADV7619_IO_REG_INTERRUPT_MASKB_1                          =0x46,
    ADV7619_IO_BIT_STDI_DATA_VALID_MB1                        =Bit(4),
    ADV7619_IO_BIT_CP_UNLOCK_MB1                              =Bit(3),
    ADV7619_IO_BIT_CP_LOCK_MB1                                =Bit(2),

    ADV7619_IO_REG_RAW_STATUS_2                               =0x47,
    ADV7619_IO_BIT_MPU_STIM_INTRQ_RAW                         =Bit(7),

    ADV7619_IO_REG_INTERRUPT_STATUS_2                         =0x48,
    ADV7619_IO_BIT_MPU_STIM_INTRQ_ST                          =Bit(7),

    ADV7619_IO_REG_INTERRUPT_CLEAR_2                          =0x49,
    ADV7619_IO_REG_INTERRUPT2_MASKB_2                         =0x4A,
    ADV7619_IO_BIT_MPU_STIM_INTRQ_MB2                         =Bit(7),

    ADV7619_IO_REG_INTERRUPT_MASKB_2                          =0x4B,
    ADV7619_IO_BIT_MPU_STIM_INTRQ_MB1                         =Bit(7),

    ADV7619_IO_REG_RAW_STATUS_6                               =0x5B,
    ADV7619_IO_BIT_CP_LOCK_CH1_RAW                            =Bit(3),
    ADV7619_IO_BIT_CP_UNLOCK_CH1_RAW                          =Bit(2),
    ADV7619_IO_BIT_STDI_DVALID_CH1_RAW                        =Bit(1),

    ADV7619_IO_REG_INTERRUPT_STATUS_6                         =0x5C,
    ADV7619_IO_BIT_CP_LOCK_CH1_ST                             =Bit(3),
    ADV7619_IO_BIT_CP_UNLOCK_CH1_ST                           =Bit(2),
    ADV7619_IO_BIT_STDI_DVALID_CH1_ST                         =Bit(1),

    ADV7619_IO_REG_INTERRUPT_CLEAR_6                          =0x5D,
    ADV7619_IO_REG_INTERRUPT2_MASKB_6                         =0x5E,
    ADV7619_IO_BIT_CP_LOCK_CH1_MB2                            =Bit(3),
    ADV7619_IO_BIT_CP_UNLOCK_CH1_MB2                          =Bit(2),
    ADV7619_IO_BIT_STDI_DVALID_CH1_MB2                        =Bit(1),

    ADV7619_IO_REG_INTERRUPT_MASKB_6                          =0x5F,
    ADV7619_IO_BIT_CP_LOCK_CH1_MB1                            =Bit(3),
    ADV7619_IO_BIT_CP_UNLOCK_CH1_MB1                          =Bit(2),
    ADV7619_IO_BIT_STDI_DVALID_CH1_MB1                        =Bit(1),

    ADV7619_IO_REG_HDMI_LVL_RAW_STATUS_1                      =0x60,
    ADV7619_IO_BIT_ISRC2_PCKT_RAW                             =Bit(7),
    ADV7619_IO_BIT_ISRC1_PCKT_RAW                             =Bit(6),
    ADV7619_IO_BIT_ACP_PCKT_RAW                               =Bit(5),
    ADV7619_IO_BIT_VS_INFO_RAW                                =Bit(4),
    ADV7619_IO_BIT_MS_INFO_RAW                                =Bit(3),
    ADV7619_IO_BIT_SPD_INFO_RAW                               =Bit(2),
    ADV7619_IO_BIT_AUDIO_INFO_RAW                             =Bit(1),
    ADV7619_IO_BIT_AVI_INFO_RAW                               =Bit(0),

    ADV7619_IO_REG_HDMI_LVL_INT_STATUS_1                      =0x61,
    ADV7619_IO_BIT_ISRC2_PCKT_ST                              =Bit(7),
    ADV7619_IO_BIT_ISRC1_PCKT_ST                              =Bit(6),
    ADV7619_IO_BIT_ACP_PCKT_ST                                =Bit(5),
    ADV7619_IO_BIT_VS_INFO_ST                                 =Bit(4),
    ADV7619_IO_BIT_MS_INFO_ST                                 =Bit(3),
    ADV7619_IO_BIT_SPD_INFO_ST                                =Bit(2),
    ADV7619_IO_BIT_AUDIO_INFO_ST                              =Bit(1),
    ADV7619_IO_BIT_AVI_INFO_ST                                =Bit(0),

    ADV7619_IO_REG_HDMI_LVL_INT_CLR_1                         =0x62,

    ADV7619_IO_REG_HDMI_LVL_INT2_MASKB_1                      =0x63,
    ADV7619_IO_BIT_ISRC2_PCKT_MB2                             =Bit(7),
    ADV7619_IO_BIT_ISRC1_PCKT_MB2                             =Bit(6),
    ADV7619_IO_BIT_ACP_PCKT_MB2                               =Bit(5),
    ADV7619_IO_BIT_VS_INFO_MB2                                =Bit(4),
    ADV7619_IO_BIT_MS_INFO_MB2                                =Bit(3),
    ADV7619_IO_BIT_SPD_INFO_MB2                               =Bit(2),
    ADV7619_IO_BIT_AUDIO_INFO_MB2                             =Bit(1),
    ADV7619_IO_BIT_AVI_INFO_MB2                               =Bit(0),

    ADV7619_IO_REG_HDMI_LVL_INT_MASKB_1                       =0x64,
    ADV7619_IO_BIT_ISRC2_PCKT_MB1                             =Bit(7),
    ADV7619_IO_BIT_ISRC1_PCKT_MB1                             =Bit(6),
    ADV7619_IO_BIT_ACP_PCKT_MB1                               =Bit(5),
    ADV7619_IO_BIT_VS_INFO_MB1                                =Bit(4),
    ADV7619_IO_BIT_MS_INFO_MB1                                =Bit(3),
    ADV7619_IO_BIT_SPD_INFO_MB1                               =Bit(2),
    ADV7619_IO_BIT_AUDIO_INFO_MB1                             =Bit(1),
    ADV7619_IO_BIT_AVI_INFO_MB1                               =Bit(0),

    ADV7619_IO_REG_HDMI_LVL_RAW_STATUS_2                      =0x65,
    ADV7619_IO_BIT_CS_DATA_VALID_RAW                          =Bit(7),
    ADV7619_IO_BIT_INTERNAL_MUTE_RAW                          =Bit(6),
    ADV7619_IO_BIT_AV_MUTE_RAW                                =Bit(5),
    ADV7619_IO_BIT_AUDIO_CH_MD_RAW                            =Bit(4),
    ADV7619_IO_BIT_HDMI_MODE_RAW                              =Bit(3),
    ADV7619_IO_BIT_GEN_CTL_PCKT_RAW                           =Bit(2),
    ADV7619_IO_BIT_AUDIO_C_PCKT_RAW                           =Bit(1),
    ADV7619_IO_BIT_GAMUT_MDATA_RAW                            =Bit(0),

    ADV7619_IO_REG_HDMI_LVL_INT_STATUS_2                      =0x66,
    ADV7619_IO_BIT_CS_DATA_VALID_ST                           =Bit(7),
    ADV7619_IO_BIT_INTERNAL_MUTE_ST                           =Bit(6),
    ADV7619_IO_BIT_AV_MUTE_ST                                 =Bit(5),
    ADV7619_IO_BIT_AUDIO_CH_MD_ST                             =Bit(4),
    ADV7619_IO_BIT_HDMI_MODE_ST                               =Bit(3),
    ADV7619_IO_BIT_GEN_CTL_PCKT_ST                            =Bit(2),
    ADV7619_IO_BIT_AUDIO_C_PCKT_ST                            =Bit(1),
    ADV7619_IO_BIT_GAMUT_MDATA_ST                             =Bit(0),

    ADV7619_IO_REG_HDMI_LVL_INT_CLR_2                         =0x67,

    ADV7619_IO_REG_HDMI_LVL_INT2_MASKB_2                      =0x68,
    ADV7619_IO_BIT_CS_DATA_VALID_MB2                          =Bit(7),
    ADV7619_IO_BIT_INTERNAL_MUTE_MB2                          =Bit(6),
    ADV7619_IO_BIT_AV_MUTE_MB2                                =Bit(5),
    ADV7619_IO_BIT_AUDIO_CH_MD_MB2                            =Bit(4),
    ADV7619_IO_BIT_HDMI_MODE_MB2                              =Bit(3),
    ADV7619_IO_BIT_GEN_CTL_PCKT_MB2                           =Bit(2),
    ADV7619_IO_BIT_AUDIO_C_PCKT_MB2                           =Bit(1),
    ADV7619_IO_BIT_GAMUT_MDATA_MB2                            =Bit(0),

    ADV7619_IO_REG_HDMI_LVL_INT_MASKB_2                       =0x69,
    ADV7619_IO_BIT_CS_DATA_VALID_MB1                          =Bit(7),
    ADV7619_IO_BIT_INTERNAL_MUTE_MB1                          =Bit(6),
    ADV7619_IO_BIT_AV_MUTE_MB1                                =Bit(5),
    ADV7619_IO_BIT_AUDIO_CH_MD_MB1                            =Bit(4),
    ADV7619_IO_BIT_HDMI_MODE_MB1                              =Bit(3),
    ADV7619_IO_BIT_GEN_CTL_PCKT_MB1                           =Bit(2),
    ADV7619_IO_BIT_AUDIO_C_PCKT_MB1                           =Bit(1),
    ADV7619_IO_BIT_GAMUT_MDATA_MB1                            =Bit(0),

    ADV7619_IO_REG_HDMI_LVL_RAW_STATUS_3                      =0x6A,
    ADV7619_IO_BIT_CABLE_DET_B_RAW                            =Bit(7),
    ADV7619_IO_BIT_TMDSPLL_LCK_A_RAW                          =Bit(6),
    ADV7619_IO_BIT_TMDSPLL_LCK_B_RAW                          =Bit(5),
    ADV7619_IO_BIT_TMDS_CLK_A_RAW                             =Bit(4),
    ADV7619_IO_BIT_TMDS_CLK_B_RAW                             =Bit(3),
    ADV7619_IO_BIT_VIDEO_3D_RAW                               =Bit(2),
    ADV7619_IO_BIT_V_LOCKED_RAW                               =Bit(1),
    ADV7619_IO_BIT_DE_REGEN_LCK_RAW                           =Bit(0),

    ADV7619_IO_REG_HDMI_LVL_INT_STATUS_3                      =0x6B,
    ADV7619_IO_BIT_CABLE_DET_B_ST                             =Bit(7),
    ADV7619_IO_BIT_TMDSPLL_LCK_A_ST                           =Bit(6),
    ADV7619_IO_BIT_TMDSPLL_LCK_B_ST                           =Bit(5),
    ADV7619_IO_BIT_TMDS_CLK_A_ST                              =Bit(4),
    ADV7619_IO_BIT_TMDS_CLK_B_ST                              =Bit(3),
    ADV7619_IO_BIT_VIDEO_3D_ST                                =Bit(2),
    ADV7619_IO_BIT_V_LOCKED_ST                                =Bit(1),
    ADV7619_IO_BIT_DE_REGEN_LCK_ST                            =Bit(0),

    ADV7619_IO_REG_HDMI_LVL_INT_CLR_3                         =0x6C,  //tt 0605
    ADV7619_IO_REG_HDMI_LVL_INT2_MASKB_3                      =0x6D,
    ADV7619_IO_BIT_CABLE_DET_B_MB2                            =Bit(7),
    ADV7619_IO_BIT_TMDSPLL_LCK_A_MB2                          =Bit(6),
    ADV7619_IO_BIT_TMDSPLL_LCK_B_MB2                          =Bit(5),
    ADV7619_IO_BIT_TMDS_CLK_A_MB2                             =Bit(4),
    ADV7619_IO_BIT_TMDS_CLK_B_MB2                             =Bit(3),
    ADV7619_IO_BIT_VIDEO_3D_MB2                               =Bit(2),
    ADV7619_IO_BIT_V_LOCKED_MB2                               =Bit(1),
    ADV7619_IO_BIT_DE_REGEN_LCK_MB2                           =Bit(0),

    ADV7619_IO_REG_HDMI_LVL_INT_MASKB_3                       =0x6E,
    ADV7619_IO_BIT_CABLE_DET_B_MB1                            =Bit(7),
    ADV7619_IO_BIT_TMDSPLL_LCK_A_MB1                          =Bit(6),
    ADV7619_IO_BIT_TMDSPLL_LCK_B_MB1                          =Bit(5),
    ADV7619_IO_BIT_TMDS_CLK_A_MB1                             =Bit(4),
    ADV7619_IO_BIT_TMDS_CLK_B_MB1                             =Bit(3),
    ADV7619_IO_BIT_VIDEO_3D_MB1                               =Bit(2),
    ADV7619_IO_BIT_V_LOCKED_MB1                               =Bit(1),
    ADV7619_IO_BIT_DE_REGEN_LCK_MB1                           =Bit(0),

    ADV7619_IO_REG_HDMI_LVL_RAW_STATUS_4                      =0x6F,
    ADV7619_IO_BIT_HDMI_ENCRPT_A_RAW                          =Bit(2),
    ADV7619_IO_BIT_HDMI_ENCRPT_B_RAW                          =Bit(1),
    ADV7619_IO_BIT_CABLE_DET_A_RAW                            =Bit(0),

    ADV7619_IO_REG_HDMI_LVL_INT_STATUS_4                      =0x70,
    ADV7619_IO_BIT_HDMI_ENCRPT_A_ST                           =Bit(2),
    ADV7619_IO_BIT_HDMI_ENCRPT_B_ST                           =Bit(1),
    ADV7619_IO_BIT_CABLE_DET_A_ST                             =Bit(0),

    ADV7619_IO_REG_HDMI_LVL_INT_CLR_4                         =0x71,
    ADV7619_IO_REG_HDMI_LVL_INT2_MASKB_4                      =0x72,
    ADV7619_IO_BIT_HDMI_ENCRPT_A_MB2                          =Bit(2),
    ADV7619_IO_BIT_HDMI_ENCRPT_B_MB2                          =Bit(1),
    ADV7619_IO_BIT_CABLE_DET_A_MB2                            =Bit(0),

    ADV7619_IO_REG_HDMI_LVL_INT_MASKB_4                       =0x73,
    ADV7619_IO_BIT_HDMI_ENCRPT_A_MB1                          =Bit(2),
    ADV7619_IO_BIT_HDMI_ENCRPT_B_MB1                          =Bit(1),
    ADV7619_IO_BIT_CABLE_DET_A_MB1                            =Bit(0),

    ADV7619_IO_REG_HDMI_EDG_RAW_STATUS_1                      =0x79,
    ADV7619_IO_BIT_NEW_ISRC2_PCKT_RAW                         =Bit(7),
    ADV7619_IO_BIT_NEW_ISRC1_PCKT_RAW                         =Bit(6),
    ADV7619_IO_BIT_NEW_ACP_PCKT_RAW                           =Bit(5),
    ADV7619_IO_BIT_NEW_VS_INFO_RAW                            =Bit(4),
    ADV7619_IO_BIT_NEW_MS_INFO_RAW                            =Bit(3),
    ADV7619_IO_BIT_NEW_SPD_INFO_RAW                           =Bit(2),
    ADV7619_IO_BIT_NEW_AUDIO_INFO_RAW                         =Bit(1),
    ADV7619_IO_BIT_NEW_AVI_INFO_RAW                           =Bit(0),

    ADV7619_IO_REG_HDMI_EDG_INT_STATUS_1                      =0x7A,
    ADV7619_IO_BIT_NEW_ISRC2_PCKT_ST                          =Bit(7),
    ADV7619_IO_BIT_NEW_ISRC1_PCKT_ST                          =Bit(6),
    ADV7619_IO_BIT_NEW_ACP_PCKT_ST                            =Bit(5),
    ADV7619_IO_BIT_NEW_VS_INFO_ST                             =Bit(4),
    ADV7619_IO_BIT_NEW_MS_INFO_ST                             =Bit(3),
    ADV7619_IO_BIT_NEW_SPD_INFO_ST                            =Bit(2),
    ADV7619_IO_BIT_NEW_AUDIO_INFO_ST                          =Bit(1),
    ADV7619_IO_BIT_NEW_AVI_INFO_ST                            =Bit(0),

    ADV7619_IO_REG_HDMI_EDG_INT_CLR_1                         =0x7B,

    ADV7619_IO_REG_HDMI_EDG_INT2_MASKB_1                      =0x7C,
    ADV7619_IO_BIT_NEW_ISRC2_PCKT_MB2                         =Bit(7),
    ADV7619_IO_BIT_NEW_ISRC1_PCKT_MB2                         =Bit(6),
    ADV7619_IO_BIT_NEW_ACP_PCKT_MB2                           =Bit(5),
    ADV7619_IO_BIT_NEW_VS_INFO_MB2                            =Bit(4),
    ADV7619_IO_BIT_NEW_MS_INFO_MB2                            =Bit(3),
    ADV7619_IO_BIT_NEW_SPD_INFO_MB2                           =Bit(2),
    ADV7619_IO_BIT_NEW_AUDIO_INFO_MB2                         =Bit(1),
    ADV7619_IO_BIT_NEW_AVI_INFO_MB2                           =Bit(0),

    ADV7619_IO_REG_HDMI_EDG_INT_MASKB_1                       =0x7D,
    ADV7619_IO_BIT_NEW_ISRC2_PCKT_MB1                         =Bit(7),
    ADV7619_IO_BIT_NEW_ISRC1_PCKT_MB1                         =Bit(6),
    ADV7619_IO_BIT_NEW_ACP_PCKT_MB1                           =Bit(5),
    ADV7619_IO_BIT_NEW_VS_INFO_MB1                            =Bit(4),
    ADV7619_IO_BIT_NEW_MS_INFO_MB1                            =Bit(3),
    ADV7619_IO_BIT_NEW_SPD_INFO_MB1                           =Bit(2),
    ADV7619_IO_BIT_NEW_AUDIO_INFO_MB1                         =Bit(1),
    ADV7619_IO_BIT_NEW_AVI_INFO_MB1                           =Bit(0),

    ADV7619_IO_REG_HDMI_EDG_RAW_STATUS_2                      =0x7E,
    ADV7619_IO_BIT_FIFO_NEAR_OVFL_RAW                         =Bit(7),
    ADV7619_IO_BIT_FIFO_UNDERFLO_RAW                          =Bit(6),
    ADV7619_IO_BIT_FIFO_OVERFLO_RAW                           =Bit(5),
    ADV7619_IO_BIT_CTS_PASS_THRSH_RAW                         =Bit(4),
    ADV7619_IO_BIT_CHANGE_N_RAW                               =Bit(3),
    ADV7619_IO_BIT_PACKET_ERROR_RAW                           =Bit(2),
    ADV7619_IO_BIT_AUDIO_PCKT_ERR_RAW                         =Bit(1),
    ADV7619_IO_BIT_NEW_GAMUT_MDATA_RAW                        =Bit(0),

    ADV7619_IO_REG_HDMI_EDG_INT_STATUS_2                      =0x7F,
    ADV7619_IO_BIT_FIFO_NEAR_OVFL_ST                          =Bit(7),
    ADV7619_IO_BIT_FIFO_UNDERFLO_ST                           =Bit(6),
    ADV7619_IO_BIT_FIFO_OVERFLO_ST                            =Bit(5),
    ADV7619_IO_BIT_CTS_PASS_THRSH_ST                          =Bit(4),
    ADV7619_IO_BIT_CHANGE_N_ST                                =Bit(3),
    ADV7619_IO_BIT_PACKET_ERROR_ST                            =Bit(2),
    ADV7619_IO_BIT_AUDIO_PCKT_ERR_ST                          =Bit(1),
    ADV7619_IO_BIT_NEW_GAMUT_MDATA_ST                         =Bit(0),

    ADV7619_IO_REG_HDMI_EDG_INT_CLR_2                         =0x80,

    ADV7619_IO_REG_HDMI_EDG_INT2_MASKB_2                      =0x81,
    ADV7619_IO_BIT_FIFO_NEAR_OVFL_MB2                         =Bit(7),
    ADV7619_IO_BIT_FIFO_UNDERFLO_MB2                          =Bit(6),
    ADV7619_IO_BIT_FIFO_OVERFLO_MB2                           =Bit(5),
    ADV7619_IO_BIT_CTS_PASS_THRSH_MB2                         =Bit(4),
    ADV7619_IO_BIT_CHANGE_N_MB2                               =Bit(3),
    ADV7619_IO_BIT_PACKET_ERROR_MB2                           =Bit(2),
    ADV7619_IO_BIT_AUDIO_PCKT_ERR_MB2                         =Bit(1),
    ADV7619_IO_BIT_NEW_GAMUT_MDATA_MB2                        =Bit(0),

    ADV7619_IO_REG_HDMI_EDG_INT_MASKB_2                       =0x82,
    ADV7619_IO_BIT_FIFO_NEAR_OVFL_MB1                         =Bit(7),
    ADV7619_IO_BIT_FIFO_UNDERFLO_MB1                          =Bit(6),
    ADV7619_IO_BIT_FIFO_OVERFLO_MB1                           =Bit(5),
    ADV7619_IO_BIT_CTS_PASS_THRSH_MB1                         =Bit(4),
    ADV7619_IO_BIT_CHANGE_N_MB1                               =Bit(3),
    ADV7619_IO_BIT_PACKET_ERROR_MB1                           =Bit(2),
    ADV7619_IO_BIT_AUDIO_PCKT_ERR_MB1                         =Bit(1),
    ADV7619_IO_BIT_NEW_GAMUT_MDATA_MB1                        =Bit(0),

    ADV7619_IO_REG_HDMI_EDG_RAW_STATUS_3                      =0x83,
    ADV7619_IO_BIT_DEEP_COLOR_CHNG_RAW                        =Bit(7),
    ADV7619_IO_BIT_VCLK_CHNG_RAW                              =Bit(6),
    ADV7619_IO_BIT_AUDIO_MODE_CHNG_RAW                        =Bit(5),
    ADV7619_IO_BIT_PARITY_ERROR_RAW                           =Bit(4),
    ADV7619_IO_BIT_NEW_SAMP_RT_RAW                            =Bit(3),
    ADV7619_IO_BIT_AUDIO_FLT_LINE_RAW                         =Bit(2),
    ADV7619_IO_BIT_NEW_TMDS_FRQ_RAW                           =Bit(1),
    ADV7619_IO_BIT_FIFO_NEAR_UFLO_RAW                         =Bit(0),

    ADV7619_IO_REG_HDMI_EDG_STATUS_3                          =0x84,
    ADV7619_IO_BIT_DEEP_COLOR_CHNG_ST                         =Bit(7),
    ADV7619_IO_BIT_VCLK_CHNG_ST                               =Bit(6),
    ADV7619_IO_BIT_AUDIO_MODE_CHNG_ST                         =Bit(5),
    ADV7619_IO_BIT_PARITY_ERROR_ST                            =Bit(4),
    ADV7619_IO_BIT_NEW_SAMP_RT_ST                             =Bit(3),
    ADV7619_IO_BIT_AUDIO_FLT_LINE_ST                          =Bit(2),
    ADV7619_IO_BIT_NEW_TMDS_FRQ_ST                            =Bit(1),
    ADV7619_IO_BIT_FIFO_NEAR_UFLO_ST                          =Bit(0),

    ADV7619_IO_REG_HDMI_EDG_INT_CLR_3                         =0x85,

    ADV7619_IO_REG_HDMI_EDG_INT2_MASKB_3                      =0x86,
    ADV7619_IO_BIT_DEEP_COLOR_CHNG_MB2                        =Bit(7),
    ADV7619_IO_BIT_VCLK_CHNG_MB2                              =Bit(6),
    ADV7619_IO_BIT_AUDIO_MODE_CHNG_MB2                        =Bit(5),
    ADV7619_IO_BIT_PARITY_ERROR_MB2                           =Bit(4),
    ADV7619_IO_BIT_NEW_SAMP_RT_MB2                            =Bit(3),
    ADV7619_IO_BIT_AUDIO_FLT_LINE_MB2                         =Bit(2),
    ADV7619_IO_BIT_NEW_TMDS_FRQ_MB2                           =Bit(1),
    ADV7619_IO_BIT_FIFO_NEAR_UFLO_MB2                         =Bit(0),

    ADV7619_IO_REG_HDMI_EDG_INT_MASKB_3                       =0x87,
    ADV7619_IO_BIT_DEEP_COLOR_CHNG_MB1                        =Bit(7),
    ADV7619_IO_BIT_VCLK_CHNG_MB1                              =Bit(6),
    ADV7619_IO_BIT_AUDIO_MODE_CHNG_MB1                        =Bit(5),
    ADV7619_IO_BIT_PARITY_ERROR_MB1                           =Bit(4),
    ADV7619_IO_BIT_NEW_SAMP_RT_MB1                            =Bit(3),
    ADV7619_IO_BIT_AUDIO_FLT_LINE_MB1                         =Bit(2),
    ADV7619_IO_BIT_NEW_TMDS_FRQ_MB1                           =Bit(1),
    ADV7619_IO_BIT_FIFO_NEAR_UFLO_MB1                         =Bit(0),

    ADV7619_IO_REG_HDMI_EDG_RAW_STATUS_4                      =0x88,
    ADV7619_IO_BIT_MS_INF_CKS_ERR_RAW                         =Bit(7),
    ADV7619_IO_BIT_SPD_INF_CKS_ERR_RAW                        =Bit(6),
    ADV7619_IO_BIT_AUD_INF_CKS_ERR_RAW                        =Bit(5),
    ADV7619_IO_BIT_AVI_INF_CKS_ERR_RAW                        =Bit(4),
    ADV7619_IO_BIT_RI_EXPIRED_B_RAW                           =Bit(3),
    ADV7619_IO_BIT_RI_EXPIRED_A_RAW                           =Bit(2),
    ADV7619_IO_BIT_AKSV_UPDATE_B_RAW                          =Bit(1),
    ADV7619_IO_BIT_AKSV_UPDATE_A_RAW                          =Bit(0),

    ADV7619_IO_REG_HDMI_EDG_STATUS_4                          =0x89,
    ADV7619_IO_BIT_MS_INF_CKS_ERR_ST                          =Bit(7),
    ADV7619_IO_BIT_SPD_INF_CKS_ERR_ST                         =Bit(6),
    ADV7619_IO_BIT_AUD_INF_CKS_ERR_ST                         =Bit(5),
    ADV7619_IO_BIT_AVI_INF_CKS_ERR_ST                         =Bit(4),
    ADV7619_IO_BIT_RI_EXPIRED_B_ST                            =Bit(3),
    ADV7619_IO_BIT_RI_EXPIRED_A_ST                            =Bit(2),
    ADV7619_IO_BIT_AKSV_UPDATE_B_ST                           =Bit(1),
    ADV7619_IO_BIT_AKSV_UPDATE_A_ST                           =Bit(0),

    ADV7619_IO_REG_HDMI_EDG_INT_CLR_4                         =0x8A,

    ADV7619_IO_REG_HDMI_EDG_INT2_MASKB_4                      =0x8B,
    ADV7619_IO_BIT_MS_INF_CKS_ERR_MB2                         =Bit(7),
    ADV7619_IO_BIT_SPD_INF_CKS_ERR_MB2                        =Bit(6),
    ADV7619_IO_BIT_AUD_INF_CKS_ERR_MB2                        =Bit(5),
    ADV7619_IO_BIT_AVI_INF_CKS_ERR_MB2                        =Bit(4),
    ADV7619_IO_BIT_RI_EXPIRED_B_MB2                           =Bit(3),
    ADV7619_IO_BIT_RI_EXPIRED_A_MB2                           =Bit(2),
    ADV7619_IO_BIT_AKSV_UPDATE_B_MB2                          =Bit(1),
    ADV7619_IO_BIT_AKSV_UPDATE_A_MB2                          =Bit(0),

    ADV7619_IO_REG_HDMI_EDG_INT_MASKB_4                       =0x8C,
    ADV7619_IO_BIT_MS_INF_CKS_ERR_MB1                         =Bit(7),
    ADV7619_IO_BIT_SPD_INF_CKS_ERR_MB1                        =Bit(6),
    ADV7619_IO_BIT_AUD_INF_CKS_ERR_MB1                        =Bit(5),
    ADV7619_IO_BIT_AVI_INF_CKS_ERR_MB1                        =Bit(4),
    ADV7619_IO_BIT_RI_EXPIRED_B_MB1                           =Bit(3),
    ADV7619_IO_BIT_RI_EXPIRED_A_MB1                           =Bit(2),
    ADV7619_IO_BIT_AKSV_UPDATE_B_MB1                          =Bit(1),
    ADV7619_IO_BIT_AKSV_UPDATE_A_MB1                          =Bit(0),

    ADV7619_IO_REG_HDMI_EDG_RAW_STATUS_5                      =0x8D,
    ADV7619_IO_BIT_BG_MEAS_DONE_RAW                           =Bit(1),
    ADV7619_IO_BIT_VS_INF_CKS_ERR_RAW                         =Bit(0),

    ADV7619_IO_REG_HDMI_EDG_STATUS_5                          =0x8E,
    ADV7619_IO_BIT_BG_MEAS_DONE_ST                            =Bit(1),
    ADV7619_IO_BIT_VS_INF_CKS_ERR_ST                          =Bit(0),

    ADV7619_IO_REG_HDMI_EDG_INT_CLR_5                         =0x8F,

    ADV7619_IO_REG_HDMI_EDG_INT2_MASKB_5                      =0x90,
    ADV7619_IO_BIT_BG_MEAS_DONE_MB2                           =Bit(1),
    ADV7619_IO_BIT_VS_INF_CKS_ERR_MB2                         =Bit(0),

    ADV7619_IO_REG_HDMI_EDG_INT_MASKB_5                       =0x91,
    ADV7619_IO_BIT_BG_MEAS_DONE_MB1                           =Bit(1),
    ADV7619_IO_BIT_VS_INF_CKS_ERR_MB1                         =Bit(0),

    ADV7619_IO_REG_CEC_STATUS1_RAW                            =0x92,
    ADV7619_IO_BIT_CEC_RX_RDY2_RAW                            =Bit(5),
    ADV7619_IO_BIT_CEC_RX_RDY1_RAW                            =Bit(4),
    ADV7619_IO_BIT_CEC_RX_RDY0_RAW                            =Bit(3),
    ADV7619_IO_BIT_CEC_TX_RETRY_TIMEOUT_RAW                   =Bit(2),
    ADV7619_IO_BIT_CEC_TX_ARBITRATION_LOST_RAW                =Bit(1),
    ADV7619_IO_BIT_CEC_TX_READY_RAW                           =Bit(0),

    ADV7619_IO_REG_CEC_STATUS1_INT_STATUS                     =0x93,
    ADV7619_IO_BIT_CEC_RX_RDY2_ST                             =Bit(5),
    ADV7619_IO_BIT_CEC_RX_RDY1_ST                             =Bit(4),
    ADV7619_IO_BIT_CEC_RX_RDY0_ST                             =Bit(3),
    ADV7619_IO_BIT_CEC_TX_RETRY_TIMEOUT_ST                    =Bit(2),
    ADV7619_IO_BIT_CEC_TX_ARBITRATION_LOST_ST                 =Bit(1),
    ADV7619_IO_BIT_CEC_TX_READY_ST                            =Bit(0),

    ADV7619_IO_REG_CEC_STATUS1_INT_CLEAR                      =0x94,

    ADV7619_IO_REG_CEC_STATUS1_INT2_MASKB                     =0x95,
    ADV7619_IO_BIT_CEC_RX_RDY2_MB2                            =Bit(5),
    ADV7619_IO_BIT_CEC_RX_RDY1_MB2                            =Bit(4),
    ADV7619_IO_BIT_CEC_RX_RDY0_MB2                            =Bit(3),
    ADV7619_IO_BIT_CEC_TX_RETRY_TIMEOUT_MB2                   =Bit(2),
    ADV7619_IO_BIT_CEC_TX_ARBITRATION_LOST_MB2                =Bit(1),
    ADV7619_IO_BIT_CEC_TX_READY_MB2                           =Bit(0),

    ADV7619_IO_REG_CEC_STATUS1_INT1_MASKB                     =0x96,
    ADV7619_IO_BIT_CEC_RX_RDY2_MB1                            =Bit(5),
    ADV7619_IO_BIT_CEC_RX_RDY1_MB1                            =Bit(4),
    ADV7619_IO_BIT_CEC_RX_RDY0_MB1                            =Bit(3),
    ADV7619_IO_BIT_CEC_TX_RETRY_TIMEOUT_MB1                   =Bit(2),
    ADV7619_IO_BIT_CEC_TX_ARBITRATION_LOST_MB1                =Bit(1),
    ADV7619_IO_BIT_CEC_TX_READY_MB1                           =Bit(0),

    ADV7619_IO_REG_CEC_RAW_STATUS2                            =0x97,
    ADV7619_IO_REG_CEC_INTERRUPT_STATUS2                      =0x98,
    ADV7619_IO_REG_CEC_INTERRUPT_CLEAR2                       =0x99,
    ADV7619_IO_REG_CEC_INTERRUPT2_MASKB                       =0x9A,
    ADV7619_IO_REG_CEC_INTERRUPT_MASKB                        =0x9B,

    ADV7619_IO_REG_IO_REG_E0                                  =0xE0,
    ADV7619_IO_BIT_DS_WITHOUT_FILTER                          =Bit(7),

    ADV7619_IO_REG_IO_REG_E7                                  =0xE7,
    ADV7619_IO_BIT_DPP_LUMA_HBW_SEL                           =Bit(5),
    ADV7619_IO_BIT_DPP_CHROMA_LOW_EN                          =Bit(4),

    ADV7619_IO_REG_IO_REG_RD_INFO_1                           =0xEA,
    ADV7619_IO_REG_IO_REG_RD_INFO_2                           =0xEB,
    ADV7619_IO_REG_CEC_SLAVE_ADDRESS                          =0xF4,
    ADV7619_IO_REG_INFOFRAME_SLAVE_ADDRESS                    =0xF5,
    ADV7619_IO_REG_AFE_SLAVE_ADDRESS                          =0xF8,
    ADV7619_IO_REG_KSV_SLAVE_ADDRESS                          =0xF9,
    ADV7619_IO_REG_EDID_SLAVE_ADDRESS                         =0xFA,
    ADV7619_IO_REG_HDMI_SLAVE_ADDRESS                         =0xFB,
    ADV7619_IO_REG_CP_SLAVE_ADDRESS                           =0xFD,
    ADV7619_IO_REG_IO_REG_FF                                  =0xFF,
    ADV7619_IO_BIT_MAIN_RESET                                =Bit(7),   
      
}ADV7619_IO_REG_E;

#ifdef __cplusplus
}
#endif

#endif /* ADV7619_REG_H */

