 /*
 *Driver for the card pcie bridge.

 *Copyright (C) 2019 AVerMedia TECHNOLOGIES, Inc.

 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.

 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.

 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef THREAD_MODEL_H
#define THREAD_MODEL_H

#ifdef __cplusplus
extern "C" {
#endif
    
    #define TASK_MODEL_CXT_ID fourcc_id('T','A','S','K')

    typedef void (*task_work_func_t)(void *data);
    typedef void (*task_done_callback_func_t)(void *data);
    typedef void *task_model_handle_t;
    typedef void *task_handle_t;
    

    task_model_handle_t task_model_init(cxt_mgr_handle_t cxt_mgr);
    
    void task_model_stop_task(task_model_handle_t task_model_handle,task_handle_t task_handle);
    task_handle_t task_model_create_task(task_model_handle_t task_model_handle,task_work_func_t work_func,void *work_cxt,const char *name);
    void task_model_release_task(task_model_handle_t task_model_handle,task_handle_t task_handle);
    void task_model_run_task(task_model_handle_t task_model_handle,task_handle_t task_handle);
    void task_model_run_task_after(task_model_handle_t task_model_handle,task_handle_t task_handle,unsigned int us);
    void task_model_run_task_period(task_model_handle_t task_model_handle,task_handle_t task_handle,unsigned int period_ms,int count,task_done_callback_func_t cb_func);
    void sys_run_task(task_handle_t task_handle);
    void sys_task_run_task_after(task_handle_t task_handle,unsigned int us);
    void sys_task_run_period(task_handle_t task_handle,unsigned int period_ms,int count,task_done_callback_func_t cb_func);
    void task_model_schedule_DPC(task_model_handle_t task_model_handle,task_handle_t task_handle);
    

    
#ifdef __cplusplus
}
#endif

#endif /* THREAD_MODEL_H */

