 /*
 *Driver for the card pcie bridge.

 *Copyright (C) 2019 AVerMedia TECHNOLOGIES, Inc.

 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.

 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.

 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
 
#ifndef MODULE_V4L2_FRAMEGRABBER_PRIV_H_
#define MODULE_V4L2_FRAMEGRABBER_PRIV_H_

#define FRAMEGRABBER_MAX_INPUT_NUM 8

#define FRAMEGRABBER_MAX_AVISIZE 30 //same as adv7619

typedef struct
{
	BASIC_CXT_HANDLE_DECLARE;
	const char *name;
	framegrabber_framesize_mask_e framesize_cap;
	framegrabber_refreshrate_e 	framesize_info[FRAMEGRABBER_SUPPORT_FRAMESIZE_NUM];
}framegrabber_input_info_t;


typedef struct
{
	int input_no;
	framegrabber_input_info_t input_info[FRAMEGRABBER_MAX_INPUT_NUM];
	framegrabber_property_t property;
	int current_input;
	framegrabber_input_status_e current_input_status;
	framegrabber_status_bitmask_e current_status;
	framegrabber_pixfmt_bitmask_e pixfmt_cap;
	framegrabber_frame_size_t current_out_framesize;
	framegrabber_frame_size_t current_input_framesize;
	framegrabber_framemode_e framemode;
	enum framegrabber_audio_sample current_audiorate;
	int current_framerate;
	int current_out_framerate;
	int current_denominator;
	int current_out_pixfmt;
	int current_bchs_value;
	int current_bchs_selection;
	BOOL_T current_input_interlace;
	unsigned max_supported_width;
    unsigned max_frame_size;
	//struct v4l2_device *v4l2_dev;
	void *data;
	int current_dual_pixel;
	int current_fpga_bypassmode;
	int current_output_pixelformat;

	framegrabber_interface_t interface;
    unsigned int hdcp_flag;
    
    int ITU_flag;
    
    U8_T current_aviinfoframe[FRAMEGRABBER_MAX_AVISIZE];
    U8_T current_vendorinfoframe[FRAMEGRABBER_MAX_AVISIZE];
    U8_T current_audioinfoframe[FRAMEGRABBER_MAX_AVISIZE];
}framegrabber_context_t;

#endif /* MODULE_V4L2_FRAMEGRABBER_PRIV_H_ */
