 /*
 *Driver for the card pcie bridge.

 *Copyright (C) 2019 AVerMedia TECHNOLOGIES, Inc.

 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.

 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.

 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
 

#ifndef V4L2_MODEL_DEVICE_H_
#define V4L2_MODEL_DEVICE_H_
#include "framegrabber.h"

#define EDID_BYTES	256
typedef struct edid_data
{
	unsigned char edid[EDID_BYTES];
	int size;
}edid_data_t;


#if 1
struct v4l2_dump_flash {
	__u32 pad;
	__u32 start_block;
	__u32 blocks;
	__u32 reserved[5];
	__u8  *flash;
};
#endif

typedef struct
{
	v4l2_model_callback_t callback;
	v4l2_model_callback_parameter_t data;
}v4l2_model_callback_item_t;

typedef struct 
{
	struct list_head list;
	v4l2_model_ioctl_hook_func_t ioctl_hook_func;
	void *data;
}v4l2_model_ioctl_hook_item_t;

typedef struct
{
	v4l2_model_buffer_info_t *vbuf_info;
	//unsigned lines;
	unsigned int rcv_size;

}framebuffer_info_t;

typedef struct v4l2_model_context_s
{
	struct v4l2_device v4l2_dev;
	struct video_device vdev;
	struct vb2_queue queue;
	struct mutex lock;
    struct device *dev;

	void  *vb2_context;
	v4l2_model_device_setup_t device_info;
	v4l2_model_callback_item_t callbacks[V4L2_MODEL_CALLBACK_NUM];

	struct list_head ioctl_hook_list[HOOK_IOCTL_TYPE_NUM];
	framegrabber_handle_t framegrabber_handle;
	framebuffer_info_t current_framebuf_info;
	int inibuffer_create;
	int inibuffer_index;
}v4l2_model_context_t;
 

#define V4L2_MODEL_DEBUG(fmt, ...) //printk(fmt, ##__VA_ARGS__)


#endif /* V4L2_MODEL_DEVICE_H_ */
